<template>
  <div id="app" style="width: 1400px; margin: 0 auto">
    <div class="alert alert-info" role="alert">
      See how many features have been added over time by tier and stage. The
      diagrams are interactive, so click around in order to filter the data!
      <br />
      Data is parsed from
      <a
        href="https://gitlab.com/gitlab-com/www-gitlab-com/-/tree/master/data%2Frelease_posts"
      >
        release posts </a
      >, so
      <a
        href="https://about.gitlab.com/blog/2021/01/26/new-gitlab-product-subscription-model/"
      >
        removed feature tiers
      </a>
      might still be present in older releases.
    </div>
    <div v-if="loading">Loading...</div>
    <div v-show="!loading">
      <div class="row" style="margin-left: 20px; margin-top: 20px">
        <div id="dc-pie-chart"><h4>License Tier</h4></div>
        <div style="margin-left: 40px; font-size: 12px">
          <div id="dc-stage-select-chart"><h4>Stage</h4></div>
          "unspecified" refers to features that don't have a stage defined (like
          announcements)<br />
          as well as features released before 11.06.
        </div>
      </div>
      <div id="dc-stacked-chart" style="margin-left: 20px; margin-top: 30px">
        <h4>Features by License Tier</h4>
      </div>
      <div
        id="dc-stacked-stage-chart"
        style="clear: both; margin-left: 20px; margin-top: 30px"
      >
        <h4>Features by Stage</h4>
      </div>
      <div id="dc-data-count" style="margin-left: 20px; margin-top: 10px">
        <span class="filter-count"></span> selected out of
        <span class="total-count"></span> features
      </div>
    </div>
  </div>
</template>
<script>
import crossfilter from "crossfilter2";
import * as d3 from "d3";
import * as dc from "dc";

export default {
  components: {},
  el: "#app",
  data() {
    return {
      loading: true,
      data: [],
    };
  },
  async mounted() {
    this.data = (
      await fetch("./features_split.json").then((response) => response.json())
    ).flat();
    this.$parent.pageView({ page: "stats" });
    this.loading = false;
    this.datafilter = crossfilter(this.data);
    this.releaseDimension = null;
    this.releaseGroup = null;
    this.featureTierDimension = null;
    this.featureTierGroup = null;
    this.stackedDimension = null;
    this.stackedGroup = null;
    this.stacks = null;
    this.stageSelectDimension = null;
    this.stageSelectGroup = null;
    this.stageStackDimension = null;
    this.stageStackGroup = null;
    this.stageStacks = null;
    this.releases = this.compileReleases();
    this.generateCharts();
    const params = new URLSearchParams();
    params.set("tab", "stats");
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  updated() {},
  methods: {
    compileReleases() {
      var releases = [];
      for (const element in this.data) {
        releases.push(this.data[element].version);
      }
      var uniqueReleases = releases.filter((v, i, a) => a.indexOf(v) === i);
      return uniqueReleases;
    },
    stack_data(group) {
      return {
        all: function () {
          var all = group.all(),
            m = {};
          // build matrix from multikey/value pairs
          all.forEach(function (kv) {
            var ks = kv.key.split("_");
            m[ks[0]] = m[ks[0]] || {};
            m[ks[0]][ks[1]] = kv.value;
          });
          // then produce multivalue key/value pairs
          return Object.keys(m).map(function (k) {
            return { key: k, value: m[k] };
          });
        },
      };
    },
    generateStackedChart() {
      // Define and render the bar chart
      var barChart = dc.barChart("#dc-stacked-chart");
      barChart
        .width(1400)
        .height(450)
        .x(d3.scaleBand())
        .xUnits(dc.units.ordinal)
        .yAxisLabel("Number of Features")
        .elasticX(true)
        .yAxisPadding("10%")
        //core, starter, premium, ultimate
        .ordinalColors(["#6E49CB", "#380D75", "#DB3B21", "#FCA121"])
        .dimension(this.stackDimension)
        .group(this.stacks, "core", function (d) {
          return d.value["core"] || 0;
        })
        .stack(this.stacks, "starter", function (d) {
          return d.value["starter"] || 0;
        })
        .stack(this.stacks, "premium", function (d) {
          return d.value["premium"] || 0;
        })
        .stack(this.stacks, "ultimate", function (d) {
          return d.value["ultimate"] || 0;
        })
        .title("core", function (d) {
          return d.key + " core: " + d.value["core"];
        })
        .title("premium", function (d) {
          return d.key + " premium: " + d.value["premium"];
        })
        .title("starter", function (d) {
          return d.key + " starter: " + d.value["starter"];
        })
        .title("ultimate", function (d) {
          return d.key + " ultimate: " + d.value["ultimate"];
        })
        .transitionDelay(250)
        .renderLabel(true);

      barChart.selectAll("text .barLabel").attr("font-size","15")
      barChart.on('pretransition', function(chart) {
        var chart_width = chart.width();
        chart.selectAll("text.barLabel").attr('font-size', function(data) {
          let total_bars = chart.group().all().length;
          let sing_bar_width = Math.floor(chart_width / total_bars);
          return (sing_bar_width * .5) + "px";
        });
      });
      barChart.render();
      barChart.filter = function () {};
    },
    generateStackedStageChart() {
      // Define and render the bar chart
      var barChart = dc.barChart("#dc-stacked-stage-chart");
      barChart
        .width(1400)
        .height(450)
        .x(d3.scaleBand())
        .xUnits(dc.units.ordinal)
        .yAxisLabel("Number of Features")
        .elasticX(true)
        .yAxisPadding("10%")
        .ordinalColors([
        "#380D75",
        "#49226A",
        "#772381",
        "#9A227C",
        "#B4205A",
        "#CF1D23",
        "#D32C26",
        "#D6402E",
        "#D95437",
        "#DD6740",
        "#E07949",
        "#E38B52",
        "#E59B5B",
        "#E8AB65",
        "#EABA6E",
        "#EDC778",
        "#EFD482",
        "#F1DF8C",
        "#F3E996",
        "#F5F2A0",
        "#F4F7AA"
        ])
        .dimension(this.stageSelectDimension)
        .group(this.stageStacks, "unspecified", function (d) {
          return d.value["unspecified"];
        })
        .stack(this.stageStacks, "manage", function (d) {
          return d.value["manage"] || 0;
        })
        .stack(this.stageStacks, "performance", function (d) {
          return d.value["performance"] || 0;
        })
        .stack(this.stageStacks, "verify", function (d) {
          return d.value["verify"] || 0;
        })
        .stack(this.stageStacks, "create", function (d) {
          return d.value["create"] || 0;
        })
        .stack(this.stageStacks, "secure", function (d) {
          return d.value["secure"] || 0;
        })
        .stack(this.stageStacks, "release", function (d) {
          return d.value["release"] || 0;
        })
        .stack(this.stageStacks, "usability", function (d) {
          return d.value["usability"] || 0;
        })
        .stack(this.stageStacks, "systems", function (d) {
          return d.value["systems"] || 0;
        })
        .stack(this.stageStacks, "monitor", function (d) {
          return d.value["monitor"] || 0;
        })
        .stack(this.stageStacks, "configure", function (d) {
          return d.value["configure"] || 0;
        })
        .stack(this.stageStacks, "plan", function (d) {
          return d.value["plan"] || 0;
        })
        .stack(this.stageStacks, "package", function (d) {
          return d.value["package"] || 0;
        })
        .stack(this.stageStacks, "data_stores", function (d) {
          return d.value["data_stores"] || 0;
        })
        .stack(this.stageStacks, "govern", function (d) {
          return d.value["govern"] || 0;
        })
        .stack(this.stageStacks, "enablement", function (d) {
          return d.value["enablement"] || 0;
        })
        .stack(this.stageStacks, "growth", function (d) {
          return d.value["growth"] || 0;
        })
        .stack(this.stageStacks, "anti-abuse", function (d) {
          return d.value["anti-abuse"] || 0;
        })
        .stack(this.stageStacks, "modelops", function (d) {
          return d.value["modelops"] || 0;
        })
        .title("unspecified", function (d) {
          return d.key + " unspecified: " + d.value["unspecified"];
        })
        .title("manage", function (d) {
          return d.key + " manage: " + d.value["manage"];
        })
        .title("performance", function (d) {
          return d.key + " performance: " + d.value["performance"];
        })
        .title("verify", function (d) {
          return d.key + " verify: " + d.value["verify"];
        })
        .title("create", function (d) {
          return d.key + " create: " + d.value["create"];
        })
        .title("secure", function (d) {
          return d.key + " secure: " + d.value["secure"];
        })
        .title("release", function (d) {
          return d.key + " release: " + d.value["release"];
        })
        .title("usability", function (d) {
          return d.key + " usability: " + d.value["usability"];
        })
        .title("systems", function (d) {
          return d.key + " systems: " + d.value["systems"];
        })
        .title("monitor", function (d) {
          return d.key + " monitor: " + d.value["monitor"];
        })
        .title("configure", function (d) {
          return d.key + " configure: " + d.value["configure"];
        })
        .title("plan", function (d) {
          return d.key + " plan: " + d.value["plan"];
        })
        .title("package", function (d) {
          return d.key + " package: " + d.value["package"];
        })
        .title("data-stores", function (d) {
          return d.key + " data-stores: " + d.value["data-stores"];
        })
        .title("govern", function (d) {
          return d.key + " govern: " + d.value["govern"];
        })
        .title("enablement", function (d) {
          return d.key + " enablement: " + d.value["enablement"];
        })
        .title("growth", function (d) {
          return d.key + " growth: " + d.value["growth"];
        })
        .title("anti-abuse", function (d) {
          return d.key + " anti-abuse: " + d.value["anti-abuse"];
        })
        .title("modelops", function (d) {
          return d.key + " modelops: " + d.value["modelops"];
        })
        .transitionDelay(500)
        .renderLabel(true);

      barChart.on('pretransition', function(chart) {
        var chart_width = chart.width();
        chart.selectAll("text.barLabel").attr('font-size', function(data) {
          let total_bars = chart.group().all().length;
          let sing_bar_width = Math.floor(chart_width / total_bars);
          return (sing_bar_width * .5) + "px";
        });
      });

      barChart.render();
      barChart.filter = function () {};
    },
    generateDataCount() {
      // Define and render the count chart
      var countChart = dc.dataCount("#dc-data-count");
      countChart.dimension(this.datafilter).group(this.datafilter.groupAll());
      countChart.render();
    },
    generatePieChart() {
      var pieChart = dc.pieChart("#dc-pie-chart");
      pieChart
        .width(300)
        .height(300)
        .radius(200)
        .innerRadius(50)
        //core, premium, ultimate, starter
        .ordinalColors(["#6E49CB", "#DB3B21", "#FCA121", "#380D75"])
        .dimension(this.featureTierDimension)
        .group(this.featureTierGroup)
        .legend();
      const super_legendables = pieChart.legendables;
      pieChart.legendables = function () {
        const items = super_legendables.call(this);

        const ordered_items = [{}, {}, {}, {}];
        for (var i in items) {
          if (items[i]["name"] == "core") {
            ordered_items[3] = items[i];
          } else if (items[i]["name"] == "starter") {
            ordered_items[2] = items[i];
          } else if (items[i]["name"] == "premium") {
            ordered_items[1] = items[i];
          } else if (items[i]["name"] == "ultimate") {
            ordered_items[0] = items[i];
          }
        }
        return ordered_items;
      };
      pieChart.render();
    },
    generateStageSelectChart() {
      var stageChart = dc.rowChart("#dc-stage-select-chart");
      stageChart
        .width(500)
        .height(300)
        .ordinalColors([
        "#380D75",
        "#49226A",
        "#772381",
        "#9A227C",
        "#B4205A",
        "#CF1D23",
        "#D32C26",
        "#D6402E",
        "#D95437",
        "#DD6740",
        "#E07949",
        "#E38B52",
        "#E59B5B",
        "#E8AB65",
        "#EABA6E",
        "#EDC778",
        "#EFD482",
        "#F1DF8C",
        "#F3E996",
        "#F5F2A0",
        "#F4F7AA"
        ])
        .dimension(this.stageSelectDimension)
        .labelOffsetX(-80)
        .margins({ top: 0, right: 0, bottom: 0, left: 80 })
        .group(this.stageSelectGroup)
        .elasticX(true);
      stageChart.render();
    },
    resetCharts() {
      dc.filterAll();
      dc.renderAll();
    },
    generateCharts() {
      this.releaseDimension = this.datafilter.dimension(function (data) {
        return data.version.replace("_", ".");
      });
      this.releaseGroup = this.releaseDimension.group();

      this.stageSelectDimension = this.datafilter.dimension(function (data) {
        return data.stage ? data.stage : "unspecified";
      });
      this.stageSelectGroup = this.stageSelectDimension.group();

      this.stageStackDimension = this.datafilter.dimension(function (data) {
        var stage = data.stage ? data.stage : "unspecified";
        return data.version.replace("_", ".") + "_" + stage;
      });
      this.stageStackGroup = this.stageStackDimension.group();

      this.stageStacks = this.stack_data(this.stageStackGroup);

      this.featureTierDimension = this.datafilter.dimension(function (data) {
        var tier = data.available_in?.[0] ?? 'core';
        if (tier == "silver") tier = "premium";
        if (tier == "bronze") tier = "starter";
        if (tier == "gold") tier = "ultimate";
        if (tier == "free") tier = "core";
        return tier;
      });
      this.featureTierGroup = this.featureTierDimension.group();

      this.stackDimension = this.datafilter.dimension(function (data) {
        var tier = data.available_in?.[0] ?? 'core';
        if (tier == "silver") tier = "premium";
        if (tier == "bronze") tier = "starter";
        if (tier == "gold") tier = "ultimate";
        if (tier == "free") tier = "core";
        return data.version.replace("_", ".") + "_" + tier;
      });
      this.stackedGroup = this.stackDimension.group();
      this.stacks = this.stack_data(this.stackedGroup);
      // Generate the charts
      this.generateStackedChart();
      this.generatePieChart();
      this.generateDataCount();
      this.generateStageSelectChart();
      this.generateStackedStageChart();
    },
  },
  computed: {},
};
</script>
